#include<math.h>
#include"random.h"

/* double c,cd,cm,u[97],uvec[97] ; */
double c,cd,cm,u[97];
int i97,j97 ;

void rmarin(int ij, int kl)
/* Initialize ranmar */
{
  int i,ii,j,jj,k,l,m ;
  double s,t ;

  i = ((ij/177) % 177) + 2 ;
  j = (ij % 177) + 2 ;
  k = ((kl/169) % 178) + 1 ;
  l = kl % 169 ;
  for (ii=0; ii<97; ii++)
    {
      s = 0.0 ;
      t = 0.5 ;
      for (jj=0; jj<24; jj++)
	{
	  m = (((i*j) % 179) * k) % 179 ;
	  i = j ;
	  j = k ;
	  k = m ;
	  l = (53*l + 1) % 169 ;
	  if ( ((l*m) % 64) >= 32) s += t ;
	  t *= 0.5 ;
	}
      u[ii] = s ;
    }
  c   =  362436.0 / 16777216.0 ;
  cd  = 7654321.0 / 16777216.0 ;
  cm  =16777213.0 / 16777216.0 ;
  i97 = 96 ;
  j97 = 32 ;
}



double ranmar(void)
{
  double uni;

  uni=u[i97]-u[j97];
  if (uni<0.0) uni+=1.0;
  u[i97]=uni;
  if (--i97<0) i97=96;
  if (--j97<0) j97=96;
  c-=cd;
  if (c<0.0) c+=cm;
  uni-=c;
  if (uni<0.0) uni+=1.0;
  return(uni);
}

double gasdev(void)
{
  static int iset=0;
  static double gset;
  double fac,r,v1,v2;
  
  if  (iset == 0) {
    do {
      v1=2.0*ranmar()-1.0;
      v2=2.0*ranmar()-1.0;
      r=v1*v1+v2*v2;
    } while (r >= 1.0);
    fac=sqrt(-2.0*log(r)/r);
    gset=v1*fac;
    iset=1;
    return v2*fac;
  } else {
    iset=0;
    return gset;
  }
}


double realrand(double lo, double hi)
/* Subroutine to return real random numbers in the range lo<x<hi */
{
  double unit;

  unit = ranmar();
  return lo + (hi-lo)*unit;
}


#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349

double ran1(int *idum)
{
	static long ix1,ix2,ix3;
	static double r[98];
	double temp;
	static int iff=0;
	int j;

	if (*idum < 0 || iff == 0) {
		iff=1;
		ix1=(IC1-(*idum)) % M1;
		ix1=(IA1*ix1+IC1) % M1;
		ix2=ix1 % M2;
		ix1=(IA1*ix1+IC1) % M1;
		ix3=ix1 % M3;
		for (j=1;j<=97;j++) {
			ix1=(IA1*ix1+IC1) % M1;
			ix2=(IA2*ix2+IC2) % M2;
			r[j]=(ix1+ix2*RM2)*RM1;
		}
		*idum=1;
	}
	ix1=(IA1*ix1+IC1) % M1;
	ix2=(IA2*ix2+IC2) % M2;
	ix3=(IA3*ix3+IC3) % M3;
	j=1 + ((97*ix3)/M3);
/*	if (j > 97 || j < 1) fprintf(stderr,"RAN1: This cannot happen.\n");*/
	temp=r[j];
	r[j]=(ix1+ix2*RM2)*RM1;
	return temp;
}

#undef M1
#undef IA1
#undef IC1
#undef RM1
#undef M2
#undef IA2
#undef IC2
#undef RM2
#undef M3
#undef IA3
#undef IC3





